From c7450abbccfb3dbcdf4ced3a54b94ef0529c0bd6 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Fr=C3=A9d=C3=A9ric=20P=C3=A9ters?= <fpeters@entrouvert.com>
Date: Tue, 10 May 2022 14:46:54 +0200
Subject: [PATCH] templates: remove spaces before question marks (#65077)

---
 .../manager/templates/authentic2/manager/delete.html        | 2 +-
 .../authentic2/manager/role_remove_admin_role.html          | 2 +-
 .../authentic2/manager/role_remove_admin_user.html          | 2 +-
 src/authentic2/templates/authentic2/logout_confirm.html     | 2 +-
 .../templates/interaction/consent_federation.html           | 6 ++++--
 .../templates/authentic2_idp_oidc/authorization.html        | 2 +-
 6 files changed, 9 insertions(+), 7 deletions(-)

diff --git a/src/authentic2/manager/templates/authentic2/manager/delete.html b/src/authentic2/manager/templates/authentic2/manager/delete.html
index 50a0251a..f71cf18e 100644
--- a/src/authentic2/manager/templates/authentic2/manager/delete.html
+++ b/src/authentic2/manager/templates/authentic2/manager/delete.html
@@ -9,7 +9,7 @@
     {% csrf_token %}
     <div class="form-inner-container">
       {% block caption %}
-      <p>{% blocktrans %}Do you want to delete {{ model_name }} {{ object }} ?{% endblocktrans %}</p>
+      <p>{% blocktrans %}Do you want to delete {{ model_name }} {{ object }}?{% endblocktrans %}</p>
       {% endblock %}
       <div class="buttons">
         <button class="delete-button">{% trans "Delete" %}</button>
diff --git a/src/authentic2/manager/templates/authentic2/manager/role_remove_admin_role.html b/src/authentic2/manager/templates/authentic2/manager/role_remove_admin_role.html
index bd355808..267d0aed 100644
--- a/src/authentic2/manager/templates/authentic2/manager/role_remove_admin_role.html
+++ b/src/authentic2/manager/templates/authentic2/manager/role_remove_admin_role.html
@@ -12,7 +12,7 @@
     {% csrf_token %}
     <div class="form-inner-container">
       {% block caption %}
-      <p>{% blocktrans %}Do you want to remove admin role {{ child }} ?{% endblocktrans %}</p>
+      <p>{% blocktrans %}Do you want to remove admin role {{ child }}?{% endblocktrans %}</p>
       {% endblock %}
       <div class="buttons">
         <button>{% trans "Remove" %}</button>
diff --git a/src/authentic2/manager/templates/authentic2/manager/role_remove_admin_user.html b/src/authentic2/manager/templates/authentic2/manager/role_remove_admin_user.html
index 9975489e..3aa74489 100644
--- a/src/authentic2/manager/templates/authentic2/manager/role_remove_admin_user.html
+++ b/src/authentic2/manager/templates/authentic2/manager/role_remove_admin_user.html
@@ -12,7 +12,7 @@
     {% csrf_token %}
     <div class="form-inner-container">
       {% block caption %}
-      <p>{% blocktrans %}Do you want to remove admin user {{ user }} ?{% endblocktrans %}</p>
+      <p>{% blocktrans %}Do you want to remove admin user {{ user }}?{% endblocktrans %}</p>
       {% endblock %}
       <div class="buttons">
         <button>{% trans "Remove" %}</button>
diff --git a/src/authentic2/templates/authentic2/logout_confirm.html b/src/authentic2/templates/authentic2/logout_confirm.html
index ad208d2e..3e2507a2 100644
--- a/src/authentic2/templates/authentic2/logout_confirm.html
+++ b/src/authentic2/templates/authentic2/logout_confirm.html
@@ -10,7 +10,7 @@
 {% endblock %}
 
 {% block content %}
-  <p>{% blocktrans %}You are going to do a global logout, do you want to continue ?{% endblocktrans %}
+  <p>{% blocktrans %}You are going to do a global logout, do you want to continue?{% endblocktrans %}
   </p>
   <p>
     <form method="post">
diff --git a/src/authentic2/templates/interaction/consent_federation.html b/src/authentic2/templates/interaction/consent_federation.html
index 08e6fff6..cd1c068d 100644
--- a/src/authentic2/templates/interaction/consent_federation.html
+++ b/src/authentic2/templates/interaction/consent_federation.html
@@ -10,9 +10,11 @@
 <div id="consent">
 <p>
 {% if provider_id %}
-{% trans "Do you accept to federate your account with " %} <strong>{{ provider_id }}</strong> ?
+{% blocktrans with provider_id=provider_id %}
+Do you accept to federate your account with <strong>{{ provider_id }}</strong>?
+{% endblocktrans %}
 {% else %}
-{% trans "Do you accept to federate your account ?" %}
+{% trans "Do you accept to federate your account?" %}
 {% endif %}
 {{ provider_id2 }}
 </p>
diff --git a/src/authentic2_idp_oidc/templates/authentic2_idp_oidc/authorization.html b/src/authentic2_idp_oidc/templates/authentic2_idp_oidc/authorization.html
index d4cf40d6..8f6abdf2 100644
--- a/src/authentic2_idp_oidc/templates/authentic2_idp_oidc/authorization.html
+++ b/src/authentic2_idp_oidc/templates/authentic2_idp_oidc/authorization.html
@@ -13,7 +13,7 @@
 {% block content %}
 <h2>{% trans "Authentication access check" %}</h2>
 <form method="post" id="a2-oidc-authorization-form">
-    <p>{% trans "Do you want to be authenticated on this service ?" %}</p>
+    <p>{% trans "Do you want to be authenticated on this service?" %}</p>
     {% if needs_scope_validation %}
       <p>{% trans "The following informations will be sent to the service:" %}</p>
       <ul>
-- 
2.36.1